Frequently asked questions in JavaScript Scheduler control

18 Nov 20184 minutes to read

This article provides answers to frequently asked questions and solutions to common issues encountered while working with the Scheduler control.

Grouping with empty resources

Enabling grouping without providing resource data causes the following issues:

  • Normal (vertical) views render but CRUD operations fail.
  • Timeline views do not render at all and display an empty scheduler table.

Recommendation: Avoid enabling grouping when no resource data is available.

Missing e-field attribute in editor template

Error: When using a custom editor template, input field values may not bind correctly if the e-field attribute is missing.

Solution: The e-field attribute is mandatory for binding input values to event fields. Add it to each editor input element. For more information, refer to the editor template documentation.

Missing CSS reference

Error Image:

Missing CSS reference

Solution:

This issue occurs when the Scheduler CSS files are not included in the project. Add the appropriate theme CSS to resolve the styling issue:

<html>
<head>
    <title>Syncfusion JavaScript Sample</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no" />
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="author" content="Syncfusion" />

    <!-- Scheduler CSS is referred from this link -->
    <link href="https://cdn.syncfusion.com/ej2/material.css" rel="stylesheet">
</head>

<body class="material">
    <div id='sample'>
        <!-- Scheduler component -->
    </div>
</body>
</html>

QuickInfoTemplate clipped at bottom

When using the quickInfoTemplate, the quick info popup may appear clipped at the bottom of the Scheduler. Resolve this by refreshing the popup position when it opens using the cellClick and eventClick events.

var eventAdded = false;

var scheduleObj = new ej.schedule.Schedule({
  // ... other options
  cellClick: onClick,
  eventClick: onClick
});

scheduleObj.appendTo('#Schedule');

function onClick(args) {
  if (!this.eventAdded) {
    let popupInstance = document.querySelector('.e-quick-popup-wrapper').ej2_instances[0];
    popupInstance.open = () => {
      popupInstance.refreshPosition();
    };
    this.eventAdded = true;
  }
}

Optionally, add CSS to ensure minimum height:

.e-schedule .e-quick-popup-wrapper {
  min-height: 232px;
}

Culture files not loaded for localization

Error Image:

Locale import issue

Problem: When using the locale property, localization fails if culture files are not loaded correctly.

Solution: Ensure all required CLDR culture files (numberingSystems, timeZoneNames, etc.) are loaded properly and the loadCultureFiles method is called before initializing the Scheduler.

loadCultureFiles();

var localeTexts;
var localeAjax = new ej.base.Ajax('./locale.json', 'GET', false);
localeAjax.onSuccess = function (value) {
  localeTexts = value;
};
localeAjax.send();
ej.base.L10n.load(JSON.parse(localeTexts));

function loadCultureFiles() {
  // Load CLDR culture files
  var files = ['ca-gregorian.json', 'numbers.json', 'numberingSystems.json', 'timeZoneNames.json'];
  var loader = ej.base.loadCldr;
  var loadCulture = function (prop) {
    var val, ajax;
    ajax = new ej.base.Ajax('./' + files[prop], 'GET', false);
    ajax.onSuccess = function (value) {
      val = value;
    };
    ajax.send();
    loader(JSON.parse(val));
  };
  for (var prop = 0; prop < files.length; prop++) {
    loadCulture(prop);
  }
}

var scheduleObj = new ej.schedule.Schedule({
  width: '100%',
  height: '550px',
  locale: 'fr-CH'
});

scheduleObj.appendTo('#Schedule');

Getting the Scheduler component instance

You can access the Scheduler component instance either from the variable used during initialization or by querying the DOM element and accessing the ej2_instances property.

var scheduleObj = new ej.schedule.Schedule({
  // ... other options
  cellClick: onClick
});

scheduleObj.appendTo('#Schedule');

function onClick(args) {
  // Method 1: Use the initialization variable
  var instance1 = scheduleObj;
  
  // Method 2: Query from the DOM element
  var instance2 = document.querySelector('.e-schedule').ej2_instances[0];
}

Frequently Asked Questions in Vue Schedule Component

18 Nov 20183 minutes to read

This section provides solutions to common issues encountered while working with the Vue Scheduler component.

Maximum Call Stack Size Exceeded

Error Image:

Maximum call stack size exceeded

Solution:

This error occurs when a view used in the Schedule component is not imported and injected. Each view such as Day, TimelineWeek, TimelineMonth, and Agenda must be injected before use. If a view is referenced without injection, the Schedule component throws a Maximum call stack size exceeded error.

In the following example, the Day view is used without injection, which results in the issue. Injecting the required view modules resolves the problem.

<template>
  <div>
    <div id="app">
      <div id="container">
        <ejs-schedule id="Schedule" width="100%" height="550px">
          <e-views>
            <e-view option="Day"></e-view>
            <e-view option="TimelineWeek"></e-view>
            <e-view option="TimelineMonth"></e-view>
            <e-view option="Agenda"></e-view>
          </e-views>
        </ejs-schedule>
      </div>
    </div>
  </div>
</template>

<script>
import Vue from "vue";
import {
  SchedulePlugin,
  TimelineViews,
  TimelineMonth,
  Agenda,
} from "@syncfusion/ej2-vue-schedule";

Grouping with Empty Resources

Grouping without providing any resource data will throw the following problems.

  • Normal(vertical) views are rendered, but you are not able to perform CRUD operations
  • Timeline views not at all render and shows empty scheduler table

So, we suggest to avoid grouping with empty resources in the scheduler.

Not providing e-field in editor template

Error: While using editor template, value of e-field is missing in editor window.

Solution: The e-field attribute is mandatory for processing field values within the editor window. Refer to the detailed guidance in the editor template documentation: here

Missing CSS Reference

Error Image:

Missing CSS reference

Solution:

This issue occurs when the required CSS files for the Schedule component are not included. Adding the appropriate CSS references resolves the problem.


      <! –– scheduler CSS is referred from this link ––>
<link href="https://cdn.syncfusion.com/ej2/tailwind3.css" rel="stylesheet">
                      or
      <! –– From here ––>

<style>
@import "/node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "/node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "/node_modules/@syncfusion/ej2-calendars/styles/tailwind3.css";
@import "/node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css";
@import "/node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "/node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "/node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "/node_modules/@syncfusion/ej2-vue-schedule/styles/tailwind3.css";
</style>

QuickInfoTemplate at bottom

When using the quickInfoTemplate in scheduler, sometimes quickinfo popup not shown fully at the bottom area of scheduler. This can be resolved by using the cellClick and eventClick events and below code snippet.

<template>
    <ejs-schedule
          id="Schedule"
          width="100%"
          height="550px"
          :cellClick="onClick"
          :eventClick="onClick"
        >
    </ejs-schedule>
</template>
 .
 .
var eventAdded = false;

methods: {
  onClick: function () {
    if (!this.eventAdded) {
      let popupInstance = document.querySelector('.e-quick-popup-wrapper').ej2_instances[0];
      popupInstance.open = () => {
        popupInstance.refreshPosition();
      };
      this.eventAdded = true;
    }
  }
}

Not Importing Culture Files When using Localization

Error Image:

Locale import issue

While using locale in scheduler, not importing the required culture files properly throws the problem.

Solution: Properly add and import the culture files(numberingSystems, timeZoneNames, loadCldr, L10n etc.,) in your project will resolve the problem.

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import enNumberData from '@syncfusion/ej2-cldr-data/main/en-GB/numbers.json';
import entimeZoneData from '@syncfusion/ej2-cldr-data/main/en-GB/timeZoneNames.json';
import enGregorian from '@syncfusion/ej2-cldr-data/main/en-GB/ca-gregorian.json';
import enNumberingSystem from '@syncfusion/ej2-cldr-data/supplemental/numberingSystems.json';

loadCldr(frNumberData, frtimeZoneData, frGregorian, frNumberingSystem);

L10n.load({
  'en-GB': {
    schedule: {
      day: 'Day',
      week: 'Week',
      workWeek: 'Work Week',
      month: 'Month'
      }
    }
  });

Frequently asked questions in React Schedule component

18 Nov 20185 minutes to read

In this article, you can find some frequently asked questions and corresponding solutions while getting hands-on experience with the React Scheduler.

Maximum call stack size exceeded

Error Image:

Maximum call stack size exceeded

Solution:

This error occurs when a scheduler views that were not imported into the project. You can resolve this issue by importing the required view modules.

In the below code, Day option is used without injecting, So, it throws the above error. You can resolve this problem by simply injecting the day module in below code.

import { render } from 'react-dom';
import * as React from 'react';
import { ScheduleComponent, ViewsDirective, ViewDirective, Agenda, TimelineViews, TimelineMonth, Inject, Resize, DragAndDrop
} from '@syncfusion/ej2-react-schedule';
import { extend } from '@syncfusion/ej2-base';
import { SampleBase } from './sample-base';
import * as dataSource from './datasource.json';

export class TimelineView extends SampleBase {
  constructor() {
    super(...arguments);
    this.data = extend([], dataSource.scheduleData.concat(dataSource.timelineData), null, true);
  }
  private eventSettings: EventSettingsModel = { dataSource: this.data };
  
  render() {
    return (<ScheduleComponent height="650px" selectedDate={new Date(2021, 0, 10)} eventSettings={this.eventSettings}>
              <ViewsDirective>
                <ViewDirective option="Day" />
                <ViewDirective option="TimelineWeek" />
                <ViewDirective option="TimelineWorkWeek" />
                <ViewDirective option="TimelineDay" />
                <ViewDirective option="Agenda" />
              </ViewsDirective>
              <Inject
                services={[ TimelineViews, TimelineMonth, Agenda, Resize, DragAndDrop]}
              />
            </ScheduleComponent>
    );
  }
}

render(<TimelineView />, document.getElementById('sample'));

Grouping with empty resources

Grouping without providing any resource data will throw the following problems.

  • Normal (vertical) views are rendered, but you are not able to perform CRUD operations
  • Timeline views do not render and display an empty scheduler table.

To avoid this, do not enable grouping when no resources are defined.

Not providing e-field in editor template

Error: When using a custom editor template, the e-field attribute value is missing in the input elements.

Solution: The e-field attribute is mandatory for each form element in the editor template. Please refer here for more info.

Missing CSS reference

Error Image:

Missing CSS reference

Solution:

The above problem occurs when missing CSS references for the scheduler in a project. You can resolve this issue by providing proper CSS for the scheduler.

<html>
<head>
    <title>Syncfusion React Sample</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no" />
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="description" content="Syncfusion React UI Components" />
    <meta name="author" content="Syncfusion" />

      <! –– scheduler CSS is referred from this link ––>
    <link href="https://cdn.syncfusion.com/ej2/material.css" rel="stylesheet">

</head>

<body class="material">
    <div id='sample'>
</body>
</html>

QuickInfoTemplate at bottom

When using the quickInfoTemplate in scheduler, sometimes quickinfo popup not shown fully at the bottom area of scheduler. You can resolve this by using cellClick and eventClick events and below code snippet.

   constructor() {
    super(...arguments);
    this.eventAdded = false;
   }
   .
   .
  onClick(args) {
    if (!this.eventAdded) {
      let popupInstance = document.querySelector('.e-quick-popup-wrapper').ej2_instances[0];
      popupInstance.open = () => {
        popupInstance.refreshPosition();
      };
      this.eventAdded = true;
    }
  }
  .
  .
  .
<ScheduleComponent id="schedule" cellClick={this.onClick.bind(this)} eventClick={this.onClick.bind(this)}>

Not importing culture files while using localization

Error Image:

Locale import issue

While using locale in scheduler, not importing the required culture files properly throws the problem.

Solution: Properly add and import the culture files(numberingSystems, timeZoneNames, loadCldr, L10n etc.,) in your project will resolve the problem.

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import enNumberData from '@syncfusion/ej2-cldr-data/main/en-GB/numbers.json';
import entimeZoneData from '@syncfusion/ej2-cldr-data/main/en-GB/timeZoneNames.json';
import enGregorian from '@syncfusion/ej2-cldr-data/main/en-GB/ca-gregorian.json';
import enNumberingSystem from '@syncfusion/ej2-cldr-data/supplemental/numberingSystems.json';

loadCldr(enNumberData, entimeZoneData, enGregorian, enNumberingSystem);

L10n.load({
  'en-GB': {
    schedule: {
      day: 'Day',
      week: 'Week',
      workWeek: 'Work Week',
      month: 'Month'
      }
    }
  });

Frequently asked questions in Angular Schedule component

18 Nov 20185 minutes to read

In this article, you can find some frequently asked questions and corresponding solutions while getting hands-on experience with the Scheduler component.

Maximum call stack size exceeded

Error Image:

Maximum call stack size exceeded

Solution:

This error occurs when a scheduler views that were not imported into the project. You can resolve this issue by importing the required view modules.

In the below code, Day option is used without injecting, So, it throws the above error. You can resolve this problem by simply injecting the day module in below code.

import { Component } from '@angular/core';
import { AgendaService, TimelineViewsService, TimelineMonthService, EventSettingsModel } from '@syncfusion/ej2-angular-schedule';

@Component({
    selector: "app-root",
    providers: [ AgendaService, TimelineViewsService, TimelineMonthService],
    // specifies the template string for the Schedule component
    template: `
    <ejs-schedule width="100%" height="550px" [selectedDate]="selectedDate" [views]="views"
      [eventSettings]="eventSettings">
      <e-resources>
        <e-resource field="OwnerId" title="Owner" name="Owners"
          [dataSource]="ownerDataSource" [allowMultiple]="allowMultipleOwner"
          textField="OwnerText" idField="Id" colorField="OwnerColor">
        </e-resource>
      </e-resources>
    </ejs-schedule>`
})
export class AppComponent {
    public selectedDate: Date = new Date(2021, 7, 1);
    // Day view service not imported but still used
    public views: Array<string> = ['Day', 'TimelineWeek', 'TimelineMonth', 'Agenda'];
    public eventSettings: EventSettingsModel = {
        dataSource: resourceData
    };
    public allowMultipleOwner: Boolean = true;
    public ownerDataSource: Object[] = [
        { OwnerText: 'Nancy', Id: 1, OwnerColor: '#ffaa00' },
        { OwnerText: 'Steven', Id: 2, OwnerColor: '#f8a398' },
        { OwnerText: 'Michael', Id: 3, OwnerColor: '#7499e1' }
    ];
}

If ScheduleAllModule was injected from module files, the above issue is not thrown.

Grouping with empty resources

Grouping without providing any resource data will throw the following problems.

  • Normal (vertical) views are rendered, but you are not able to perform CRUD operations
  • Timeline views do not render and display an empty scheduler table.

To avoid this, do not enable grouping when no resources are defined.

Not providing e-field in editor template

Error: When using a custom editor template, the e-field attribute value is missing in the input elements.

Solution: The e-field attribute is mandatory for each form element in the editor template. Please refer here for more info.

Missing CSS reference

Error Image:

Missing CSS reference

Solution:

The above problem occurs when missing CSS references for the scheduler in a project. You can resolve this issue by providing proper CSS for the scheduler.

<!doctype html>
 <html lang="en">
 <head>
  <meta charset="utf-8">
  <title>EJ2 Angular Schedule Sample</title>
  
      <! –– scheduler CSS is referred from this link ––>
  <link href="https://cdn.syncfusion.com/ej2/tailwind3.css" rel="stylesheet">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="icon" type="image/x-icon" href="favicon.ico">
 </head>
<body>
  <app-root></app-root>
</body>
</html>

QuickInfoTemplate at bottom

When using the quickInfoTemplate in scheduler, sometimes quickinfo popup not shown fully at the bottom area of scheduler. You can resolve this by using cellClick and eventClick events and below code snippet.

 template: "<ejs-schedule #schedule height="650px" (cellClick)="onClick($event)" (eventClick)="onClick($event)"></ejs-schedule>"
  .
  .
  .
  public eventAdded: boolean = false;

  onClick(args: EventClickArgs): void {
    if (!this.eventAdded) {
      let popupInstance = (document.querySelector(".e-quick-popup-wrapper") as any).ej2_instances[0];
      popupInstance.open = () => {
        popupInstance.refreshPosition();
      };
      this.eventAdded = true;
    }
  }

Not importing culture files while using localization

Error Image:

Locale import issue

While using locale in scheduler, not importing the required culture files properly throws the problem.

Solution: Properly add and import the culture files(numberingSystems, timeZoneNames, loadCldr, L10n etc.,) in your project will resolve the problem.

import { loadCldr, L10n } from '@syncfusion/ej2-base';
import enNumberData from '@syncfusion/ej2-cldr-data/main/en-GB/numbers.json';
import entimeZoneData from '@syncfusion/ej2-cldr-data/main/en-GB/timeZoneNames.json';
import enGregorian from '@syncfusion/ej2-cldr-data/main/en-GB/ca-gregorian.json';
import enNumberingSystem from '@syncfusion/ej2-cldr-data/supplemental/numberingSystems.json';

loadCldr(frNumberData, frtimeZoneData, frGregorian, frNumberingSystem);

L10n.load({
  'en-GB': {
    schedule: {
      day: 'Day',
      week: 'Week',
      workWeek: 'Work Week',
      month: 'Month'
      }
    }
  });